
//				@ROUGHLYSIMILAR function :


#ifndef ROUGHLY_FUNC_VERSION
#define ROUGHLY_FUNC_VERSION		1.0.0.0



int RoughlySimplify( LPCTSTR inString, LPTSTR outString, size_t buflen )
{
	wchar_t *temp			= NULL;
	wchar_t ch				= '\0';
	wchar_t lastch			= '\0';
	size_t j				= 0;


	if ( !inString || !outString || ( buflen < 16 ) )
		return -1;
	
	if ( inString[0] == '\0' ) {
		outString[0] = '\0';
		return 0;
	}


	temp = (wchar_t*) malloc( buflen * sizeof( wchar_t ) );
	if ( !temp )
		return -2;

	temp[j] = '\0';


	for ( size_t i = 0; inString[i]; i++ ) {

		ch = (wchar_t) CharUpperW( (LPWSTR) inString[i] );

		if ( ( ch >= 0x00c0 ) && ( ch <= 0x00ff ) ) {
			wcscat_s( temp, buflen, UnaccentedC0[ch - 0x00c0] );
			j = wcslen( temp );
			lastch = ch;
			continue;
		}
		else if ( ( ch == 0x0152 ) || ( ch == 0x0153 ) ) {
			wcscat_s( temp, buflen, L"OE" );
			j = wcslen( temp );
			lastch = ch;
			continue;
		}

		if ( iswspace( ch ) || ( ch == '-' ) || ( ch == '_' ) ) {
			ch = SPACE;

			if ( ( lastch == SPACE ) || ( lastch == '\0' ) )
				continue;
		}

		if ( ( ch == 0x27 ) || ( ch == 0x2019 ) ) {
			ch = 0x27;
			if ( !iswalpha( lastch ) || !iswalpha( inString[i + 1] ) )
				continue;
		}

		if ( ( ch != SPACE ) && ( ch != 0x27 ) && !iswalnum( ch ) )
			continue;

		if ( ch && ( j < ( buflen - 1 ) ) ) {
			temp[j++] = ch;
			temp[j] = '\0';
		}

		lastch = ch;
	}


	wcscpy_s( outString, buflen, temp );
	free( temp );
	return 0;
}



DLLExports int WINAPI f_roughlysimilar( LPTSTR String )
{
	wchar_t String1[MAX_ARG_LEN]		= L"";
	wchar_t String2[MAX_ARG_LEN]		= L"";

	int rv				= 0;


	ParseArgs( String, PARSE_BREAK_COMMAS );


	if ( arglen[0] == 0 ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Missing string1\r\n" );
		return -1;
	}

	if ( arglen[1] == 0 ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Missing string2\r\n" );
		return -1;
	}


	RoughlySimplify( arg[0], String1, MAX_ARG_LEN );
	RoughlySimplify( arg[1], String2, MAX_ARG_LEN );


	//	wprintf( L"   *  String1 = \"%s\"\r\n", String1 );
	//	wprintf( L"   *  String2 = \"%s\"\r\n", String2 );

	if ( !wcscmp( String1, String2 ) )
		rv = 1;

	wsprintf( String, L"%d", rv );
	return 0;
}



#endif	//	ROUGHLY_FUNC_VERSION


/*

	1.0.0.0		2023-09-28

*/
